# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class GetProxyLBResult:
    """
    A collection of values returned by getProxyLB.
    """
    def __init__(__self__, bind_ports=None, certificates=None, description=None, filters=None, fqdn=None, health_checks=None, icon_id=None, name=None, name_selectors=None, plan=None, proxy_networks=None, servers=None, sorry_servers=None, sticky_session=None, tag_selectors=None, tags=None, timeout=None, vip=None, vip_failover=None, id=None):
        if bind_ports and not isinstance(bind_ports, list):
            raise TypeError("Expected argument 'bind_ports' to be a list")
        __self__.bind_ports = bind_ports
        """
        The external listen ports. It contains some attributes to Bind Ports.
        """
        if certificates and not isinstance(certificates, list):
            raise TypeError("Expected argument 'certificates' to be a list")
        __self__.certificates = certificates
        """
        Certificate used to terminate SSL/TSL. It contains some attributes to Certificate.
        """
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        __self__.description = description
        """
        The description of the resource.
        """
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        __self__.filters = filters
        if fqdn and not isinstance(fqdn, str):
            raise TypeError("Expected argument 'fqdn' to be a str")
        __self__.fqdn = fqdn
        if health_checks and not isinstance(health_checks, list):
            raise TypeError("Expected argument 'health_checks' to be a list")
        __self__.health_checks = health_checks
        """
        The health check rules. It contains some attributes to Health Check.
        """
        if icon_id and not isinstance(icon_id, str):
            raise TypeError("Expected argument 'icon_id' to be a str")
        __self__.icon_id = icon_id
        """
        The ID of the icon.
        """
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        __self__.name = name
        """
        Name of the resource.
        """
        if name_selectors and not isinstance(name_selectors, list):
            raise TypeError("Expected argument 'name_selectors' to be a list")
        __self__.name_selectors = name_selectors
        if plan and not isinstance(plan, float):
            raise TypeError("Expected argument 'plan' to be a float")
        __self__.plan = plan
        """
        The plan of the resource.
        """
        if proxy_networks and not isinstance(proxy_networks, list):
            raise TypeError("Expected argument 'proxy_networks' to be a list")
        __self__.proxy_networks = proxy_networks
        if servers and not isinstance(servers, list):
            raise TypeError("Expected argument 'servers' to be a list")
        __self__.servers = servers
        """
        Real servers. It contains some attributes to Servers.
        """
        if sorry_servers and not isinstance(sorry_servers, list):
            raise TypeError("Expected argument 'sorry_servers' to be a list")
        __self__.sorry_servers = sorry_servers
        """
        The pair of IPAddress and port number of sorry-server.
        """
        if sticky_session and not isinstance(sticky_session, bool):
            raise TypeError("Expected argument 'sticky_session' to be a bool")
        __self__.sticky_session = sticky_session
        """
        The flag of enable Sticky-Session.  
        """
        if tag_selectors and not isinstance(tag_selectors, list):
            raise TypeError("Expected argument 'tag_selectors' to be a list")
        __self__.tag_selectors = tag_selectors
        if tags and not isinstance(tags, list):
            raise TypeError("Expected argument 'tags' to be a list")
        __self__.tags = tags
        """
        The tag list of the resources.
        """
        if timeout and not isinstance(timeout, float):
            raise TypeError("Expected argument 'timeout' to be a float")
        __self__.timeout = timeout
        """
        Timeout seconds. 
        """
        if vip and not isinstance(vip, str):
            raise TypeError("Expected argument 'vip' to be a str")
        __self__.vip = vip
        if vip_failover and not isinstance(vip_failover, bool):
            raise TypeError("Expected argument 'vip_failover' to be a bool")
        __self__.vip_failover = vip_failover
        """
        The flag of enable VIP Fail-Over.  
        """
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        __self__.id = id
        """
        id is the provider-assigned unique ID for this managed resource.
        """
class AwaitableGetProxyLBResult(GetProxyLBResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetProxyLBResult(
            bind_ports=self.bind_ports,
            certificates=self.certificates,
            description=self.description,
            filters=self.filters,
            fqdn=self.fqdn,
            health_checks=self.health_checks,
            icon_id=self.icon_id,
            name=self.name,
            name_selectors=self.name_selectors,
            plan=self.plan,
            proxy_networks=self.proxy_networks,
            servers=self.servers,
            sorry_servers=self.sorry_servers,
            sticky_session=self.sticky_session,
            tag_selectors=self.tag_selectors,
            tags=self.tags,
            timeout=self.timeout,
            vip=self.vip,
            vip_failover=self.vip_failover,
            id=self.id)

def get_proxy_lb(filters=None,name_selectors=None,tag_selectors=None,opts=None):
    """
    Use this data source to retrieve information about a SakuraCloud ProxyLB.
    
    :param list filters: The map of filter key and value.
    :param list name_selectors: The list of names to filtering.
    :param list tag_selectors: The list of tags to filtering.
    
    The **filters** object supports the following:
    
      * `name` (`str`) - Name of the resource.
      * `values` (`list`)

    > This content is derived from https://github.com/sacloud/terraform-provider-sakuracloud/blob/master/website/docs/d/proxylb.html.markdown.
    """
    __args__ = dict()

    __args__['filters'] = filters
    __args__['nameSelectors'] = name_selectors
    __args__['tagSelectors'] = tag_selectors
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = utilities.get_version()
    __ret__ = pulumi.runtime.invoke('sakuracloud:index/getProxyLB:getProxyLB', __args__, opts=opts).value

    return AwaitableGetProxyLBResult(
        bind_ports=__ret__.get('bindPorts'),
        certificates=__ret__.get('certificates'),
        description=__ret__.get('description'),
        filters=__ret__.get('filters'),
        fqdn=__ret__.get('fqdn'),
        health_checks=__ret__.get('healthChecks'),
        icon_id=__ret__.get('iconId'),
        name=__ret__.get('name'),
        name_selectors=__ret__.get('nameSelectors'),
        plan=__ret__.get('plan'),
        proxy_networks=__ret__.get('proxyNetworks'),
        servers=__ret__.get('servers'),
        sorry_servers=__ret__.get('sorryServers'),
        sticky_session=__ret__.get('stickySession'),
        tag_selectors=__ret__.get('tagSelectors'),
        tags=__ret__.get('tags'),
        timeout=__ret__.get('timeout'),
        vip=__ret__.get('vip'),
        vip_failover=__ret__.get('vipFailover'),
        id=__ret__.get('id'))
