# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class GSLB(pulumi.CustomResource):
    description: pulumi.Output[str]
    """
    The description of the resource.
    """
    fqdn: pulumi.Output[str]
    """
    FQDN to access this resource.
    """
    health_check: pulumi.Output[dict]
    """
    Health check rules. It contains some attributes to Health Check.
    
      * `delayLoop` (`float`) - Health check access interval (unit:`second`, default:`10`).
      * `hostHeader` (`str`) - The value of `Host` header used in http/https health check access.
      * `path` (`str`) - The request path used in http/https health check access.
      * `port` (`float`) - Port number used in tcp health check access.
      * `protocol` (`str`) - Protocol used in health check.  
        Valid value is one of the following: [ "http" / "https" / "ping" / "tcp" ]
      * `status` (`str`) - HTTP status code expected by health check access.
    """
    icon_id: pulumi.Output[str]
    """
    The ID of the icon.
    """
    name: pulumi.Output[str]
    """
    The name of the resource.
    """
    servers: pulumi.Output[list]
    """
    Real servers. It contains some attributes to Servers.
    
      * `enabled` (`bool`) - The flag for enable/disable the GSLB Server (default:`true`).
      * `ipaddress` (`str`) - The IP address of the GSLB Server.
      * `weight` (`float`) - The weight of GSLB server used when weighting is enabled in the GSLB.
    """
    sorry_server: pulumi.Output[str]
    """
    The hostname or IP address of sorry server.
    """
    tags: pulumi.Output[list]
    """
    The tag list of the resources.
    """
    weighted: pulumi.Output[bool]
    """
    The flag for enable/disable weighting (default:`true`).
    """
    def __init__(__self__, resource_name, opts=None, description=None, health_check=None, icon_id=None, name=None, servers=None, sorry_server=None, tags=None, weighted=None, __props__=None, __name__=None, __opts__=None):
        """
        Provides a SakuraCloud GSLB resource. This can be used to create, update, and delete GSLBs.
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: The description of the resource.
        :param pulumi.Input[dict] health_check: Health check rules. It contains some attributes to Health Check.
        :param pulumi.Input[str] icon_id: The ID of the icon.
        :param pulumi.Input[str] name: The name of the resource.
        :param pulumi.Input[list] servers: Real servers. It contains some attributes to Servers.
        :param pulumi.Input[str] sorry_server: The hostname or IP address of sorry server.
        :param pulumi.Input[list] tags: The tag list of the resources.
        :param pulumi.Input[bool] weighted: The flag for enable/disable weighting (default:`true`).
        
        The **health_check** object supports the following:
        
          * `delayLoop` (`pulumi.Input[float]`) - Health check access interval (unit:`second`, default:`10`).
          * `hostHeader` (`pulumi.Input[str]`) - The value of `Host` header used in http/https health check access.
          * `path` (`pulumi.Input[str]`) - The request path used in http/https health check access.
          * `port` (`pulumi.Input[float]`) - Port number used in tcp health check access.
          * `protocol` (`pulumi.Input[str]`) - Protocol used in health check.  
            Valid value is one of the following: [ "http" / "https" / "ping" / "tcp" ]
          * `status` (`pulumi.Input[str]`) - HTTP status code expected by health check access.
        
        The **servers** object supports the following:
        
          * `enabled` (`pulumi.Input[bool]`) - The flag for enable/disable the GSLB Server (default:`true`).
          * `ipaddress` (`pulumi.Input[str]`) - The IP address of the GSLB Server.
          * `weight` (`pulumi.Input[float]`) - The weight of GSLB server used when weighting is enabled in the GSLB.

        > This content is derived from https://github.com/sacloud/terraform-provider-sakuracloud/blob/master/website/docs/r/gslb.html.markdown.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['description'] = description
            if health_check is None:
                raise TypeError("Missing required property 'health_check'")
            __props__['health_check'] = health_check
            __props__['icon_id'] = icon_id
            __props__['name'] = name
            __props__['servers'] = servers
            __props__['sorry_server'] = sorry_server
            __props__['tags'] = tags
            __props__['weighted'] = weighted
            __props__['fqdn'] = None
        super(GSLB, __self__).__init__(
            'sakuracloud:index/gSLB:GSLB',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, description=None, fqdn=None, health_check=None, icon_id=None, name=None, servers=None, sorry_server=None, tags=None, weighted=None):
        """
        Get an existing GSLB resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.
        
        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: The description of the resource.
        :param pulumi.Input[str] fqdn: FQDN to access this resource.
        :param pulumi.Input[dict] health_check: Health check rules. It contains some attributes to Health Check.
        :param pulumi.Input[str] icon_id: The ID of the icon.
        :param pulumi.Input[str] name: The name of the resource.
        :param pulumi.Input[list] servers: Real servers. It contains some attributes to Servers.
        :param pulumi.Input[str] sorry_server: The hostname or IP address of sorry server.
        :param pulumi.Input[list] tags: The tag list of the resources.
        :param pulumi.Input[bool] weighted: The flag for enable/disable weighting (default:`true`).
        
        The **health_check** object supports the following:
        
          * `delayLoop` (`pulumi.Input[float]`) - Health check access interval (unit:`second`, default:`10`).
          * `hostHeader` (`pulumi.Input[str]`) - The value of `Host` header used in http/https health check access.
          * `path` (`pulumi.Input[str]`) - The request path used in http/https health check access.
          * `port` (`pulumi.Input[float]`) - Port number used in tcp health check access.
          * `protocol` (`pulumi.Input[str]`) - Protocol used in health check.  
            Valid value is one of the following: [ "http" / "https" / "ping" / "tcp" ]
          * `status` (`pulumi.Input[str]`) - HTTP status code expected by health check access.
        
        The **servers** object supports the following:
        
          * `enabled` (`pulumi.Input[bool]`) - The flag for enable/disable the GSLB Server (default:`true`).
          * `ipaddress` (`pulumi.Input[str]`) - The IP address of the GSLB Server.
          * `weight` (`pulumi.Input[float]`) - The weight of GSLB server used when weighting is enabled in the GSLB.

        > This content is derived from https://github.com/sacloud/terraform-provider-sakuracloud/blob/master/website/docs/r/gslb.html.markdown.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()
        __props__["description"] = description
        __props__["fqdn"] = fqdn
        __props__["health_check"] = health_check
        __props__["icon_id"] = icon_id
        __props__["name"] = name
        __props__["servers"] = servers
        __props__["sorry_server"] = sorry_server
        __props__["tags"] = tags
        __props__["weighted"] = weighted
        return GSLB(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

