# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class Internet(pulumi.CustomResource):
    band_width: pulumi.Output[float]
    """
    Bandwidth of outbound traffic (unit:`Mbps`).  
    Valid value is one of the following: [ 100 (default) / 250 / 500 / 1000 / 1500 / 2000 / 2500 / 3000 / 5000 ]
    """
    description: pulumi.Output[str]
    """
    The description of the resource.
    """
    enable_ipv6: pulumi.Output[bool]
    """
    The ipv6 enabled flag.
    """
    gateway: pulumi.Output[str]
    """
    The network gateway address of the switch.
    """
    graceful_shutdown_timeout: pulumi.Output[float]
    """
    The wait time (seconds) to do graceful shutdown the server connected to the resource.
    """
    icon_id: pulumi.Output[str]
    """
    The ID of the icon.
    """
    ipaddresses: pulumi.Output[list]
    """
    Global IP address list.
    """
    ipv6_nw_address: pulumi.Output[str]
    """
    The ipv6 network address.
    """
    ipv6_prefix: pulumi.Output[str]
    """
    Address prefix of ipv6 network.
    """
    ipv6_prefix_len: pulumi.Output[float]
    """
    Address prefix length of ipv6 network.
    """
    max_ipaddress: pulumi.Output[str]
    """
    Max global IP address.
    """
    min_ipaddress: pulumi.Output[str]
    """
    Min global IP address.
    """
    name: pulumi.Output[str]
    """
    The name of the resource.
    """
    nw_address: pulumi.Output[str]
    """
    The network address.
    """
    nw_mask_len: pulumi.Output[float]
    """
    Network mask length.  
    Valid value is one of the following: [ 28 (default) / 27 / 26 ]
    """
    server_ids: pulumi.Output[list]
    """
    The ID list of the servers connected to the switch.
    """
    switch_id: pulumi.Output[str]
    """
    The ID of the switch.
    """
    tags: pulumi.Output[list]
    """
    The tag list of the resources.
    """
    zone: pulumi.Output[str]
    """
    The ID of the zone to which the resource belongs.
    """
    def __init__(__self__, resource_name, opts=None, band_width=None, description=None, enable_ipv6=None, graceful_shutdown_timeout=None, icon_id=None, name=None, nw_mask_len=None, tags=None, zone=None, __props__=None, __name__=None, __opts__=None):
        """
        Provides a SakuraCloud Internet resource. This can be used to create, update, and delete Internet.
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[float] band_width: Bandwidth of outbound traffic (unit:`Mbps`).  
               Valid value is one of the following: [ 100 (default) / 250 / 500 / 1000 / 1500 / 2000 / 2500 / 3000 / 5000 ]
        :param pulumi.Input[str] description: The description of the resource.
        :param pulumi.Input[bool] enable_ipv6: The ipv6 enabled flag.
        :param pulumi.Input[float] graceful_shutdown_timeout: The wait time (seconds) to do graceful shutdown the server connected to the resource.
        :param pulumi.Input[str] icon_id: The ID of the icon.
        :param pulumi.Input[str] name: The name of the resource.
        :param pulumi.Input[float] nw_mask_len: Network mask length.  
               Valid value is one of the following: [ 28 (default) / 27 / 26 ]
        :param pulumi.Input[list] tags: The tag list of the resources.
        :param pulumi.Input[str] zone: The ID of the zone to which the resource belongs.

        > This content is derived from https://github.com/sacloud/terraform-provider-sakuracloud/blob/master/website/docs/r/internet.html.markdown.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['band_width'] = band_width
            __props__['description'] = description
            __props__['enable_ipv6'] = enable_ipv6
            __props__['graceful_shutdown_timeout'] = graceful_shutdown_timeout
            __props__['icon_id'] = icon_id
            __props__['name'] = name
            __props__['nw_mask_len'] = nw_mask_len
            __props__['tags'] = tags
            __props__['zone'] = zone
            __props__['gateway'] = None
            __props__['ipaddresses'] = None
            __props__['ipv6_nw_address'] = None
            __props__['ipv6_prefix'] = None
            __props__['ipv6_prefix_len'] = None
            __props__['max_ipaddress'] = None
            __props__['min_ipaddress'] = None
            __props__['nw_address'] = None
            __props__['server_ids'] = None
            __props__['switch_id'] = None
        super(Internet, __self__).__init__(
            'sakuracloud:index/internet:Internet',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, band_width=None, description=None, enable_ipv6=None, gateway=None, graceful_shutdown_timeout=None, icon_id=None, ipaddresses=None, ipv6_nw_address=None, ipv6_prefix=None, ipv6_prefix_len=None, max_ipaddress=None, min_ipaddress=None, name=None, nw_address=None, nw_mask_len=None, server_ids=None, switch_id=None, tags=None, zone=None):
        """
        Get an existing Internet resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.
        
        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[float] band_width: Bandwidth of outbound traffic (unit:`Mbps`).  
               Valid value is one of the following: [ 100 (default) / 250 / 500 / 1000 / 1500 / 2000 / 2500 / 3000 / 5000 ]
        :param pulumi.Input[str] description: The description of the resource.
        :param pulumi.Input[bool] enable_ipv6: The ipv6 enabled flag.
        :param pulumi.Input[str] gateway: The network gateway address of the switch.
        :param pulumi.Input[float] graceful_shutdown_timeout: The wait time (seconds) to do graceful shutdown the server connected to the resource.
        :param pulumi.Input[str] icon_id: The ID of the icon.
        :param pulumi.Input[list] ipaddresses: Global IP address list.
        :param pulumi.Input[str] ipv6_nw_address: The ipv6 network address.
        :param pulumi.Input[str] ipv6_prefix: Address prefix of ipv6 network.
        :param pulumi.Input[float] ipv6_prefix_len: Address prefix length of ipv6 network.
        :param pulumi.Input[str] max_ipaddress: Max global IP address.
        :param pulumi.Input[str] min_ipaddress: Min global IP address.
        :param pulumi.Input[str] name: The name of the resource.
        :param pulumi.Input[str] nw_address: The network address.
        :param pulumi.Input[float] nw_mask_len: Network mask length.  
               Valid value is one of the following: [ 28 (default) / 27 / 26 ]
        :param pulumi.Input[list] server_ids: The ID list of the servers connected to the switch.
        :param pulumi.Input[str] switch_id: The ID of the switch.
        :param pulumi.Input[list] tags: The tag list of the resources.
        :param pulumi.Input[str] zone: The ID of the zone to which the resource belongs.

        > This content is derived from https://github.com/sacloud/terraform-provider-sakuracloud/blob/master/website/docs/r/internet.html.markdown.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()
        __props__["band_width"] = band_width
        __props__["description"] = description
        __props__["enable_ipv6"] = enable_ipv6
        __props__["gateway"] = gateway
        __props__["graceful_shutdown_timeout"] = graceful_shutdown_timeout
        __props__["icon_id"] = icon_id
        __props__["ipaddresses"] = ipaddresses
        __props__["ipv6_nw_address"] = ipv6_nw_address
        __props__["ipv6_prefix"] = ipv6_prefix
        __props__["ipv6_prefix_len"] = ipv6_prefix_len
        __props__["max_ipaddress"] = max_ipaddress
        __props__["min_ipaddress"] = min_ipaddress
        __props__["name"] = name
        __props__["nw_address"] = nw_address
        __props__["nw_mask_len"] = nw_mask_len
        __props__["server_ids"] = server_ids
        __props__["switch_id"] = switch_id
        __props__["tags"] = tags
        __props__["zone"] = zone
        return Internet(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

