# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class Note(pulumi.CustomResource):
    class_: pulumi.Output[str]
    """
    The content body of the Note.  
    Valid value is one of the following: [ "shell" (default) / "yaml_cloud_config" ]
    """
    content: pulumi.Output[str]
    """
    The content body of the Note.
    """
    description: pulumi.Output[str]
    """
    The description of the resource.
    """
    icon_id: pulumi.Output[str]
    """
    The ID of the icon.
    """
    name: pulumi.Output[str]
    """
    The name of the resource.
    """
    tags: pulumi.Output[list]
    """
    The tag list of the resources.
    """
    def __init__(__self__, resource_name, opts=None, class_=None, content=None, icon_id=None, name=None, tags=None, __props__=None, __name__=None, __opts__=None):
        """
        Provides a SakuraCloud Note (Startup-Script) resource. This can be used to create, update, and delete Notes.
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] class_: The content body of the Note.  
               Valid value is one of the following: [ "shell" (default) / "yaml_cloud_config" ]
        :param pulumi.Input[str] content: The content body of the Note.
        :param pulumi.Input[str] icon_id: The ID of the icon.
        :param pulumi.Input[str] name: The name of the resource.
        :param pulumi.Input[list] tags: The tag list of the resources.

        > This content is derived from https://github.com/sacloud/terraform-provider-sakuracloud/blob/master/website/docs/r/note.html.markdown.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['class_'] = class_
            if content is None:
                raise TypeError("Missing required property 'content'")
            __props__['content'] = content
            __props__['icon_id'] = icon_id
            __props__['name'] = name
            __props__['tags'] = tags
            __props__['description'] = None
        super(Note, __self__).__init__(
            'sakuracloud:index/note:Note',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, class_=None, content=None, description=None, icon_id=None, name=None, tags=None):
        """
        Get an existing Note resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.
        
        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] class_: The content body of the Note.  
               Valid value is one of the following: [ "shell" (default) / "yaml_cloud_config" ]
        :param pulumi.Input[str] content: The content body of the Note.
        :param pulumi.Input[str] description: The description of the resource.
        :param pulumi.Input[str] icon_id: The ID of the icon.
        :param pulumi.Input[str] name: The name of the resource.
        :param pulumi.Input[list] tags: The tag list of the resources.

        > This content is derived from https://github.com/sacloud/terraform-provider-sakuracloud/blob/master/website/docs/r/note.html.markdown.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()
        __props__["class_"] = class_
        __props__["content"] = content
        __props__["description"] = description
        __props__["icon_id"] = icon_id
        __props__["name"] = name
        __props__["tags"] = tags
        return Note(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

